
/*======================================================================*/
/*		TITLE:			INIT				*/
/*		Function:		Game startup routines		*/
/*									*/
/*		First Edit:		10/01/88			*/
/*		Project #:						*/
/*		Programmer:		Dennis Harper			*/
/*									*/
/*		COPYRIGHT 1990/1991 ATARI GAMES CORP.			*/
/*	  UNATHORIZED REPRODUCTION, ADAPTATION, DISTRIBUTION,		*/
/*	  PERFORMANCE OR DISPLAY OF THIS COMPUTER PROGRAM OR		*/
/*	THE ASSOCIATED AUDIOVISUAL WORK	IS STRICTLY PROHIBITED.		*/
/*	       		ALL RIGHTS RESERVED.				*/
/*									*/
/*----------------------------------------------------------------------*/


#include	"rrdef.h"
#include	"gcode.h"
#include	"message.h"
#include	"vdp.h"
#include	"genesis.h"


#define	ACKINT	*(short *)INTACK

extern	OBLIST	*oblptr;
extern	ulong	frgdsp,coldsp;
extern	ulong	high_score;
extern	long	viewx,viewy;	/* View point			*/
/*extern	long	lasty;  */    	/* View point			*/
extern	short	viewz,viewz_off;
extern	long	viewy_bb; 
extern	long	strip_front;		/* Next strip boundary 		*/
extern	long	strip_back;		/* Last strip boundary crossed	*/
extern	long	strip_horizon;		/* Current limit of view	*/
extern  long    startx[]; 
extern	long	next_rot; 
extern	short	rot_dist; 
extern	short	*trkptr; 
extern	short	viewx_spd,viewy_spd;
/*extern	WORD	viewh,viewv; */
extern	WORD	strip_cur;
extern	WORD	strip_old;
extern	WORD	world,gstate,nstate,atstate;
extern  WORD    gcount;
extern	WORD	button;
extern  WORD    plyrno;
extern	BYTE	*strip_tbl[];
extern	BYTE	*striptr;
extern	BYTE	MAX_TRK,LAST_TRK,MAX_WORLD;
extern	BYTE	game;
extern	WORD	attr1pal[];
extern	char	freeze_tmr;
extern	char	pausetmr;
extern  MT      badram;
extern  MT      badcom;

#ifdef	DEVELOPMENT
extern	WORD	auxsw;
#endif

extern uchar road_buffer[];
extern uchar ram_buf[];
extern uchar road[];
extern uchar dash[];
extern uchar dash000[];
extern uchar sky1[];
extern uchar sky1000[];
extern uchar mirror[];
extern uchar mirror000[];
extern uchar track1[];
extern uchar track1000[];
extern char vdp_access_inhibit;
extern void move_color(void);
extern PALETTE color_save1; 
extern PALETTE color_save2;
extern PALETTE color_save3;
extern PALETTE color_save4;
extern WORD	RRPAL[];

	long	world_len;		/* World Y length		*/
	WORD	seed;			/* Random Number seed value	*/
	WORD	wave,leg;		/* Wave and leg indexes		*/
	WORD	leg_num;		/* Number of legs this world	*/
	WORD	game_opt;		/* EEROM game play options	*/
	WORD	strip_num;		/* Number of strips in this world */
	BYTE	difficulty;		/* Difficulty adjustment	*/
        BYTE    world_laps;		/* number of laps in this race */
   short   c_average[MAX_STRIP]; 

#ifdef	DEVELOPMENT
	BYTE	debug;			/* Debug mode			*/
#endif

	WORD	strip_len[]={96,128,128,128,
			     128,128,128,128,
			     128,128,144,128};

/* number of laps in each world */
char  max_laps[ ] = 
        { 2,3,3,3,
          3,3,3,3,
          3,3,3,3 };

/* offset number of laps by difficulty */
char lap_offset[] = 
     { 1,  0,  0,  0, 
       0,  0,  0, -1 };

/***************** From PLAY1.C *********************************/
#if 0
extern PALETTE color_save1, color_save2;
extern const PALETTE pal[];
extern PLAYER plyr;
extern CAR_DATA car[MAX_CARS];
extern CAR_DATA lrms, fall, supply_jet, shock, zoom;

extern LONG sky_org;				/* scroll value for above the horizon with 8 bits fraction */
extern ULONG topsc;

extern volatile INT timer;
extern INT curr_car;
extern INT update_dash;
extern INT speed_cap;			/* Cap off the high speed for lower waves */
extern INT score_acc;			/* Accumulator for 4 fractional bits of score */
extern INT max_tp[51][2];
extern INT car_idx;				/* Index to sin and cos tables */
extern INT shld_active;			/* Frame counter for shield active */
extern INT pt_val[MAX_VEHICLES];	/* Current values of points for shooting these objects */
extern INT fuel_acc;				/* Accumulates sfuel expenditure */
extern INT skid_acc;				/* Accumulator for skid amounts */
extern INT stopped_cnt;			/* Number of frames the player has been stopped */
extern INT stop_limit;			/* Frame delay before whiz */
extern INT spin_delay;			/* Count down flag to prevent a second spinout right away */
extern INT dframe;				/* distance counter for ave spd calc */
extern INT distance;				/* The number of whole scanlines traveled this frame */
extern INT prev_tdiff;			/* The previous value of tdiff_slp */
extern INT plyr_hsz;				/* The hsize of the player's car in pixels */
extern INT plyr_vsz;				/* The vsize of the player's car in pixels */
extern INT carpx_angle;
extern INT lives;
extern INT game_start;
extern INT first_world_bonus;
extern INT wheel_angle;
extern INT car_slp;				/* The actual direction of the car */
extern INT max_tpos;
extern INT prev_mxtp;			/* max_tpos for the previous track */
extern INT ln_speed[14];		/* Speed per lane with 8 fractional bits */
extern INT aux_next;				/* The next aux weapon which will be bestowed for a sucessful docking */
extern INT bcar_idx;				/* Wobble index for bonus cars */
extern INT flag_idx;				/* Wobble index for flags */
extern INT no_traffic;			/* Frame counter to kill off all cars except mines after LRM expld */
extern INT interlude;			/* Interlude Music selector */
extern INT rat_num;				/* Index to the traffic structure last rat intro'd */
extern INT steer_cnv;			/* Converted steering value (0 - 15) */
extern INT accel_cnv;
extern INT aux_wait;				/* Frame count delay between aux activations */
extern INT aw_use;				/* Count of aux_weapon usage */
extern INT ln_acc;				/* Accumulator for lines of distance covered */
extern INT time_diff;			/* Difficulty option time adjust */
extern INT pt_multiplier;		/* Multiplier on point values */
extern INT spd_widx;				/* Speed write index for speed targets */
extern INT spd_ridx;				/* speed read index  for speed targets */
extern INT whizz_idx;			/* Index to select the vehicle which whizzes */
extern INT laser_wait;			/* Frame counter between player's shots */
extern INT jet_vadj;				/* Adjustment to the jet's vertical position */
extern INT jet_vidx;				/* Index to jet_voff */
extern INT jet_hadj;				/* Adjustment to the jet's horizontal position */
extern INT jet_hidx;				/* Index to jet_hoff */
extern INT spo_dir;				/* Spinout direction */
extern INT gframe;				/* game frame counter */
extern INT edge_snd;
extern INT pedge_snd;
extern INT brd_active;
extern INT dsh_flash;
extern INT aux_weapons;
extern INT peel_index;
extern INT prev_scan_start;
extern INT cities[];

extern CHAR rblogo[];
extern CHAR mess[];
extern CHAR redcar[], wheels[];
extern CHAR wavenum[];
extern UCHAR road_buffer[];
extern UCHAR ram_buf[];
extern UCHAR road[];
extern UCHAR dash[];
extern UCHAR sound_num, difficulty, demo_mode, control_mode;
extern CHAR redcar_vcom_offset[];
extern CHAR lrm_x_offset[][4];
extern CHAR lrm_y_offset[][4];
extern CHAR redcar_xradius[];
extern CHAR redcar_yradius[];
extern CHAR vdp_access_inhibit;
extern CHAR v_rpt0;				/* If TRUE, you can say RALLY APPROACHING */
extern CHAR v_rpt6;				/* If TRUE, you can say WARNING / LOW FUEL */
extern CHAR v_rpt7;				/* If TRUE, you can say FUEL LEVEL CRITICAL */
extern CHAR v_rpt9;				/* If TRUE, you can say DANGER / MINES AHEAD */
extern CHAR v_rpt10;				/* If TRUE, you can say THAT'S RAD */
extern CHAR throw_lane;			/* Lane for spikers if dropper is in center */
extern CHAR vbump_trf;			/* Advance the traffic ptr in vblank */
extern CHAR steering;			/* Steering on/off flag */
extern CHAR uzi_active;			/* Frame counter for Rapid fire active */
extern CHAR aw_active;			/* Aux weapon activated */
extern CHAR auxmisd_flg;		/* TRUE if its the first missed aux weapon this game */
extern CHAR skid;					/* Skid in progress flag */
extern CHAR skidding;			/* Like steering -- and on/off switch for skidding */
extern CHAR clr_hazard;			/* If TRUE, explode mines and make GUNs UN_GUNs */
extern CHAR peel_flg;
extern CHAR drum_flg;			/* If TRUE, it's OK to start the drums */
extern CHAR stop_flg;			/* Toggles between long and short delays between whizzing */
extern CHAR next_laser;			/* Laser mount cycling register */
extern CHAR set_bonus;			/* if TRUE, the next STINGER will be a bonus stinger */
extern CHAR mine_active;
extern CHAR lofuel_flg;
extern CHAR postbl[512];		/* Traffic position table */
extern CAR_DATA border;
extern CHAR spinout_flg;		/* Flag to kick off a spinout */
extern CHAR music_over;
#endif
extern TRACK **trk_ptr;
extern TRACK *l_ptr;				/* current length */
extern TRACK **tracks[51][3];
extern TRAFFIC *traffic[51][2];
extern TRAFFIC *traffic_a1[2];
extern TRAFFIC *tshirt_traffic[][2];
extern TRAFFIC *trf_ptr;
extern LONG max_spos;			/* Max fractional track position */
extern LONG prev_mxsp;			/* max_spos for the previous track */
extern LONG speed_frac;			/* Current speed register with 8 fractional bits */
extern LONG trk_advance;
extern LONG segpos;
extern INT trkpos;
extern INT prev_trkpos;
extern INT trk_idx;
extern INT scenery_idx;
extern INT max_tpos;
extern INT prev_mxtp;			/* max_tpos for the previous track */
extern INT tcntr;					/* segment counter for 1 length */
extern INT game_mode;			/* Game mode e.g. attract */
extern INT tshirt_cnt;
extern INT speed;					/* your car's speed */
extern INT mph;					/* The displayed mph value */
extern INT tdb_idx[31];			/* Curve_idx values for each seg's current track position */
extern INT max_tp[51][2];
extern INT tdiff_slp;			/* The total slope difference between the car and track */
extern INT time;					/* the timer value in seconds */
extern INT btime;					/* Bonus time */

static void trk_init(void);

/**************************************************/

/*	Setup world by number				*/
set_world(wld)
int	wld;
{
	int	i;
	long	yinit;
	long	c_total;
	int	old,new;

	wave = wld;		

/*	res_sloop();  */			/* Reset SLOOP			*/

/*	initmess();	  */		/* Clear alphas			*/
	set_pal(wld); 			/* Setup colors			*/
	clr_all(); 			/* Clear arrays			*/

/*	if (game)       */
/*	  initmes2();	 */		/* Stop messages		*/
/*	else            */
/*	  clr_window(); */			/* Clear alpha window		*/

	strip_num = strip_len[wld];	/* Get total number of strips 	*/
	world_len = strip_num * STRIP_SIZE;	/* World Y length	*/
    world_laps = max_laps[ wld ] + lap_offset[ difficulty ];
    if ( world_laps < 2 ) world_laps = 2;

	pfinit(wld);			   /* Draw playfield		*/
	init_wave(wld);			/* RB Draw playfield		*/

/*	set_objs(wld);	*/		/* Set object vars		*/

	/* build a c_average[] table which contains the average curve for the next 8 */
	/* track sections */
/*	trk_page();		*/			/* Get track page	*/
	c_total = 0;
	for (i=0 ; i < 8; i++) 				/* Average 8 strips ahead */
	    c_total += trkptr[i]; 			/* Add up curves		*/
	c_average[ 0 ] = c_total >> 3; 

	for (i=1, old = 0, new = 8 ; i < strip_num; i++) /* Average 8 strips ahead */
	  {
	  c_total -= trkptr[old];	 		/* remove from total */
	  c_total += trkptr[new];	 		/* add into total	*/
	  c_average[ i ] = c_total >> 3; 
	  if (old++ >= strip_num) old = 0;
	  if (new++ >= strip_num) new = 0;
	  }

	strip_front = STRIP_SIZE-1;		/* Set strip triggers		*/
	strip_back = 0;
	strip_horizon = YDEPTH * STRIP_SIZE;
	strip_cur = strip_old = YDEPTH-1;
/*	viewy = lasty = 0;   remove */
					/* Get leg index		*/
	viewx = startx[ plyrno ];			/* Normal			*/
	viewz_off = VIEWZ_OFF;		/* Set z offset			*/
	viewz = viewz_off;		/* Set viewpoint		*/
	viewy_bb = viewy;		/* Set boundaries		*/
	viewx_spd = 0;			/* Clear view speeds		*/
	viewy_spd = 0;
/*	viewh = 0x2000; */ 		/* View scaling			*/
/*	viewv = 0x6000; */ 

/*	next_rot = viewy + ROT_DIST; remove */  

   
   /* Make world			*/
	for (i= 0; i < YDEPTH; i++)
	  makobj(i);
}


/*	Setup object data base variables by world			*/
set_objs(wld)
int	wld;
{
/*	if (wld >= (int)(&MAX_WORLD)) */
/*	  wld = (int)(&MAX_WORLD-1);  */

/*	striptr = strip_tbl[wld];		*/       /* Set object wld pointer */
/*	oblptr = striptr + strip_num + 2; */	/* Set oblist pointer */
}


/*	Do all local array clears		*/
clr_all()
{
/*	clrmo();	*/		/* Clear all MOs		*/

	frgdsp	&= (F_BOMB | F_BOMB1 | F_HIT | F_HIT1);			/* Clear all dispatches		*/
	coldsp = 0;
/*	freeze_tmr = 0; */			/* Clear freeze timer		*/

/*	init_enemy(); */			/* Clear collision link lists	*/
/*	init_cars();  */			/* Clear car blocks		*/
/*	clr_lasers(); */			/* Clear laser arrays		*/
/*	init_obs();	  */		/* Init obsticle blocks		*/
/*	init_ob1();	  */		/* Init obsticle type #1	*/
/*	clr_player(); */
/*	clr_drone();  */
/*	clr_bale();	  */		/* Clear hay bale stuff		*/
/*	clr_rail();	  */		/* Clear guard rails		*/

/*	init_comments(); */		/* Clear announcer commentary	*/
}

/********************** from PLAY1.C ******************************/

#define dash_start VDP_M_SCROLLA+(256*22)+(128-40)
#define mirror_start VDP_M_SCROLLA+128-28
#define sky_start1 VDP_M_SCROLLB
#define sky_start2 VDP_M_SCROLLB+128
#define track1_start1 VDP_M_SCROLLB+(256*12)+(2*11)
#define track1_start2 VDP_M_SCROLLB+(256*12)+128

/* Draw playfield		*/

init_wave(wld)
int	wld;
{
	int i, j, wave_num;
	uchar *city_ptr;
   
   uncopy(dash, ram_buf,7680); 
	vdp_access_inhibit = TRUE;
	vdp_draw_dash(160);                       
   send_vdp_pic(dash000,dash_start,39,5);  
	vdp_access_inhibit = FALSE;

   move_color();

	reset_scrolling(); 

/*	init_sprites();
*/
/*	city_ptr = (UCHAR *)cities +
		cities[sizeof(MASTER_GRAF_HEADER)/sizeof(INT) + world];
*/
	uncopy(mirror,ram_buf,4864);   
	vdp_access_inhibit = TRUE;
	vdp_draw_mirror();                               
   send_vdp_pic(mirror000,mirror_start,27,5); 
   vdp_access_inhibit = FALSE;

	uncopy(sky1,ram_buf,7520);   /* 24576);  */
	vdp_access_inhibit = TRUE;
	vdp_draw_city();                           
   send_vdp_pic(sky1000,sky_start1,63,11); 
   send_vdp_pic(sky1000,sky_start2,63,11); 
   vdp_access_inhibit = FALSE;

   load_alpha();

   print_string("test string",64,7);

   print_word(0xA5,76,7);

	vdp_access_inhibit = TRUE;
   send_vdp_pic(track1000,track1_start1,52,9); 
   send_vdp_hflip(track1000,track1_start2,52,9); 
/*	copy_road(); */
   vdp_access_inhibit = FALSE;

/*	fuel_acc = 0;
	clr_hazard = TRUE;
	peel_flg = 0;
	peel_index = 0;

	if (++interlude > 2)
		interlude = 0;
	if (scenery_idx == 49)
		interlude = 3;
	drum_flg = TRUE;
	spd_widx = 0;
	spd_ridx = 8;
	whizz_idx = 0;
	stopped_cnt = 0;
	stop_flg = 0;
	stop_limit = 300;
	spin_delay = 0;
	edge_snd = 0;
	pedge_snd = 0;
	music_over = 0;

	snd_init();
*/
/*	gframe =0;		*/	/* Attempt to sync up the attract mode */
/*	dframe =0;
	skid = 0;
	speed = 0;
	speed_frac = 0;
	distance = 0;
	laser_wait = 0;
	next_laser = 0;
*/
/*	aw_active = 0;		 */ /* Prevent a half used turbo from starting you at 298 mph */
/*	uzi_active = 0;	 */ /* Prevent a half used uzi from starting wave */
/*	shld_active = 0;	 */ /* Prevent a half used shield from starting wave */
/*	no_traffic = FALSE;*/ /* Don't continue an LRM explosion in a new wave */
/*	if (!aw_use)
	{
		dead_aux();
	}
	set_bonus = FALSE; */ /* For starting a new track */
/*	lofuel_flg = FALSE;
	jet_hadj = 0;
	jet_hidx = 0;
	jet_vadj = 0;
	jet_vidx = 0;
	dframe = 0;
	aux_wait = 0;

	for (i=0; i < 512; i++)
	{
		postbl[i] = -1;
	}

	mine_active = FALSE;
*/
	/* Set up for game execution */
/*	skid = FALSE;
	spinout_flg = 0;
	car_slp = 0;
	spo_dir = 0;

	skid_acc = 0;
	skid = FALSE;
*/
	/* Initialize the sky scrolling variables */
/*	sky_org = INITIAL_HORIZON << 8; */	/* Init the sky starting position */

/*	for (i=0; i < 14; i++)
	{
		ln_speed[i] = ((INT)lnspd_tbl[0][i]) << 8;
	}
	mph = 0;
*/	speed = 0;
	speed_frac = 0;

	trk_init();

	/* Should follow trk_init */
/*	cars_init();
	shots_init();
	plyr_init();
	tdiff_slp = 0;
	prev_tdiff = 0;
*/
/*	border.type = CHKPT;	*/	/* make sure some valid data in border */
/*	dead_car(&border);	*/	/* else vsp #0 inadvertently eliminated */
/*	prev_scan_start = 0;

	rat_num = 0;  */ 	/* keeps track of number of active cars coming in from */
							/* bottom of screen. dead_car() can make it go negative */
							/* if left-over data in car structures is inaccurate so */
							/* must be cleared here */

/* this code should follow above code since above code can cause
	some free_vsp's to occur which can inadvertently delete the redcar
	and/or the special weapon */

/*	init_vsp(REDCAR_VS, REDCAR_X, REDCAR_Y, 0, PR_3, redcar);
	init_vsp(WHEEL_VS, REDCAR_X, REDCAR_Y, 0, PR_3, wheels);

	draw_vsp(WHEEL_VS, DEFAULT_WHEELS);
	draw_vsp(REDCAR_VS, DEFAULT_REDCAR);
*/

}

static void trk_init(void)
{
	register INT i;

	tdiff_slp = 0;
	trk_advance = 0;

	for (i = 0; i < 31; i++)
		tdb_idx[i] = 0;

	segpos = 0x1f00;
	trkpos = 0x1f;
	prev_trkpos = trkpos;
	trk_idx = 0;
	trk_ptr = tracks[scenery_idx][trk_idx];
	l_ptr = *trk_ptr;
	tcntr = 31;

	max_tpos = max_tp[scenery_idx][trk_idx];
	max_spos = (max_tpos << 8) | 0xFF;
	prev_mxsp = max_spos;
	prev_mxtp = max_tpos;
#if 0
	if (game_mode != ATTRACT)
	{
		if (scenery_idx == 49)
		{
			tshirt_cnt = difficulty;	/* wave 50 track selection */
			trf_ptr = tshirt_traffic[tshirt_cnt][0];	/* Use value for traffic */
			time = MAX_FUEL;					/* Fill 'er up! */
			btime = MAX_BTIME;
		}
		else
			trf_ptr = traffic[scenery_idx][0];
	}
	else
	{
		trf_ptr = traffic_a1[0];
	}
#endif
}

reset_scrolling(void)
{
	long *ptr1, *ptr2;
	int i;

	/* unpack road graphic into local RAM (2nd half of Screen buffer) */
/*	unlz (road, &road_buffer[ROAD_SIZE]);  */

/* copy road graphic into local screen buffer */
/*	ptr1 = (LONG *)road_buffer;
	ptr2 = (LONG *)&road_buffer[ROAD_SIZE];
	for (i=0; i < (ROAD_BYTE_WIDTH/sizeof(LONG) * LINES_IN_ROAD); i++)
	{
		*ptr1++ = *ptr2++;
	}

	create_checkerboard_road();
*/
	vdp_access_inhibit = TRUE;

/*	vdp_draw_road();     */

	SET_AUTO_INC(2);


   SET_VDP_ADR(VDP_W_VRAM, VDP_M_HSCROLL);
	for (i=0; i < 256; i++)
	{
		WRITE_VDP(CENTER_SCREEN_PIXEL);
		WRITE_VDP(CENTER_SCREEN_PIXEL);
	}

	vdp_access_inhibit = FALSE;

	for (i=0; i < 16; i++)	/* set road colors for color cycling */
	{
		color_save1.rgb[i] = RRPAL[48+i];
		color_save2.rgb[i] = RRPAL[48+i];
		color_save3.rgb[i] = RRPAL[32+i];
		color_save4.rgb[i] = RRPAL[32+i];
   }
}
